#ifndef KINEMATICS_H
#define KINEMATICS_H

//#define PLUS_X2_X2

#define LINEAR_Z0
#define LINEAR_Z1

//#define WITH_RAYS
#ifdef WITH_RAYS
	#define WITH_R2PS
	#ifdef WITH_R2PS
//		#define WITH_R2PS_LINEAR
		#define WITH_R2PS_LOG
//		#define WITH_R2PS_ZZ
//		#define WITH_R2PS_ZZ_LOG
	#else	//WITH_R2PS
		#define WITH_DP
	#endif
#else
//	#define LINEAR_XI0
	#ifndef LINEAR_XI0
		#define LOG_XI0
	#endif
	#define LINEAR_XI1
#endif

#include "Kinematics_Two_P_PS.h"
#include <vector>
#include <sstream>

namespace CuTe {

namespace NS_Kinematics {

using namespace NS_Utils::NS_min_max;

inline double _SET_MIN(double &a, double b){
	return ( a > b ) ? (a = b) : a ;
}
inline double _SET_MAX(double &a, double b){
	return ( a < b ) ? (a = b) : a ;
}
inline int _SIGN(double a){
	return ( ( a < 0. ) ? (-1) : (+1) );
}

using std::cerr;
using std::cout;
using std::endl;
using std::string;
using std::stringstream;
using std::vector;
//using NS_TWO_P_PS::Two_P_PS;

//class Interval {
//public:
//	double min,max;
//
//	inline Interval()
//	:min(0.),max(0.){
//
//	}
//
//	inline Interval(double min, double max)
//	:min(min),max(max){
//
//	}
//
//	inline ~Interval(){
//
//	}
//
//	inline bool valid()const{
//		return (max>=min);
//	}
//
//	inline double size()const{
//		return max-min;
//	}
//
//	inline Interval& set_min(double min){
//		this->min	= min;
//		return *this;
//	}
//
//	inline Interval& set_max(double max){
//		this->max	= max;
//		return *this;
//	}
//
//	inline Interval& set_min_max(double min, double max){
//		this->min	= min;
//		this->max	= max;
//		return *this;
//	}
//
//	inline Interval& set_unvalid(){
//		min = +1.;
//		max	= -1.;
//		return *this;
//	}
//
//	/*
//	 * returns:
//	 * 	-1 : val < min < max
//	 *   0 : min < val < max
//	 *  +1 : min < max < val
//	 */
//	inline int region(double val)const{
//		if(val<min) return -1;
//		if(max<val) return +1;
//		return 0;
//	}
//
//	/*
//	 * set t1,t2 to
//	 * t1 | t2 |
//	 * ---|--- |
//	 * +1 | -2 : min(v2) < max(v2) < min(__) < max(__)
//	 *  0 | -1 : min(v2) < min(__) < max(v2) < max(__)
//	 * -1 |  0 : min(v2) < min(__) < max(__) < max(v2)
//	 *  0 |  0 : min(__) < min(v2) < max(v2) < max(__)
//	 *  0 | +1 : min(__) < min(v2) < max(__) < max(v2)
//	 * +1 | +2 : min(__) < max(__) < min(v2) < max(v2)
//	 */
//	inline void compare(const Interval& v2, int &t1, int &t2)const{
//		t1 = t2 = (region(v2.min));
//		int tmp(region(v2.max));
//		t1 *= tmp;
//		t2 += tmp;
//	}
//
//	inline bool disjunct(const Interval& v2)const{
//		return ( (region(v2.min))*(region(v2.max)) == (+1) );
//	}
//
//	inline bool operator<(double val)const{
//		return (max<val);
//	}
//
//	inline bool operator<=(double val)const{
//		return (max<=val);
//	}
//
//	inline bool operator>(double val)const{
//		return (val<min);
//	}
//
//	inline bool operator>=(double val)const{
//		return (val<=min);
//	}
//
//	inline bool operator==(double val)const{
//		return ( (min<=val) && (val<=max) );
//	}
//
//	inline bool operator!=(double val)const{
//		return ( (val<min) || (max<val) );
//	}
//
//	inline bool operator<(const Interval& iv)const{
//		return (max<iv.min);
//	}
//
//	inline bool operator<=(const Interval& iv)const{
//		return (max<=iv.min);
//	}
//
//	inline bool operator>(const Interval& iv)const{
//		return (min>iv.max);
//	}
//
//	inline bool operator>=(const Interval& iv)const{
//		return (min>=iv.max);
//	}
//
//	inline const string str()const{
//		stringstream ss;
//		ss	<<"["<<min<<","<<max<<"]";
//		return ss.str();
//	}
//};
////
////inline stringstream& operator<<(stringstream &ss, const Interval& I){
////	ss	<<"["<<I.min<<","<<I.max<<"]";
////	return ss;
////}
//
//class Ex_Limit:public Interval {
//public:
//	inline Ex_Limit()
//	:Interval(){
//	}
//
//	inline bool reduce(const Ex_Limit& v2){
//		if(disjunct(v2)) return false;
//		_SET_MIN(min,v2.min);
//		_SET_MAX(max,v2.max);
//		return true;
//	}
//
//};
//
//class Var_Limit: public Interval{
//public:
//	inline Var_Limit()
//	:Interval(){
//	}
//
//	inline Var_Limit& choose_min(double min){
//		_SET_MAX(this->min,min);
//		return *this;
//	}
//
//	inline Var_Limit& choose_max(double max){
//		_SET_MIN(this->max,max);
//		return *this;
//	}
//
//	inline Var_Limit& choose_min_max(double min, double max){
//		_SET_MAX(this->min,min);
//		_SET_MIN(this->max,max);
//		return *this;
//	}
//
//	inline Var_Limit& reduce(const Var_Limit& v2){
//		choose_min_max(v2.min,v2.max);
//		return *this;
//	}
//
//	inline bool reduce(const Ex_Limit& ex){
//		int t1,t2;
//		compare(ex,t1,t2);
//		if( (t1==0) && (t2==0) ){
//			// min < ex < max	-> no reduction
//			return false;
//		}
//		switch (t2) {
//			case (-2):
//				// ex < min < max	-> disjunct
//				break;
//			case (-1):
//				set_min(ex.max);
//				break;
//			case ( 0):
//				// min < ex < max	-> total exclusion
//				set_unvalid();
//				break;
//			case (+1):
//				set_max(ex.min);
//				break;
//			case (+2):
//				// min < max < ex	-> disjunct
//				break;
//			default:
//				cerr	<<"Var_Limit::reduce(const Ex_Limit& ex) WRONG t2="<<t2	<<endl;
//				break;
//		}
//
//		return true;
//	}
//
//	inline double get_a_value(const double x[1])const{
//		return ( min + (*x)*(max-min) );
//	}
//
//	inline double get_a_value_reversed(const double x[1])const{
//		return ( max - (*x)*(max-min) );
//	}
//};
////
////inline stringstream& operator<<(stringstream &ss, const Var_Limit& I){
////	ss	<<"["<<I.min<<","<<I.max<<"]";
////	return ss;
////}
//
////class _Cut{
////protected:
////	inline _Cut(){
////
////	}
////
////	inline ~_Cut(){
////
////	}
////
////};
////
////class Cut_kT: public _Cut{
////protected:
////	double a;
////	double mp2_a_m;
////	double lp2_a_m,aoE;
////
////	double *S;
////	double *M2;
////	Var_Limit qT_a;
////
////	double *q02,*ly;
////	Var_Limit nu_a;
////
////	double *nu,*Snu;
////	Var_Limit u_a;
////
////
////	inline void _set_1_M(){
////		qT_a.min	= sqrt(mp2_a_m-(*M2));
////		qT_a.max	= ((*S)-(*M2))/(2.*sqrt((*S)));
////	}
////
////	inline void _set_3_y(){
////		lp2_a_m	= mp2_a_m/(*q02);
////		aoE		= 0.5*sqrt(lp2_a_m);
////
////		double lp2( 1.-pow_2(*ly) );
////		double tmp( pow_2(lp2)+lp2_a_m*pow_2(*ly) );
////		tmp		= 1./tmp;
////
////		nu_a.min= nu_a.max = lp2_a_m*(*ly)*tmp;
////
////		tmp		*= (lp2)*sqrt(lp2*(lp2 - lp2_a_m));
////
////		nu_a.min	-= tmp;
////		nu_a.max	+= tmp;
////
////	}
////
////	inline void _set_4_nu(){
////		u_a.max	= 1./(*Snu);
////		u_a.min	= u_a.max*aoE;
////
////		u_a.max	*= u_a.max*(1-(*ly)*(*nu)-sqrt(pow_2((*ly)-(*nu)) +pow_2(aoE*(*Snu))));
////	}
////
////public:
////	inline Cut_kT(double *S, double *M2, double *q02, double *ly,double *nu, double *Snu)
////	:_Cut()
////	,a(0.)
////	,mp2_a_m(0.)
////	,lp2_a_m(0.),aoE(0.)
////	,S(S)
////	,M2(M2)
////	,qT_a()
////	,q02(q02),ly(ly)
////	,nu_a()
////	,nu(nu),Snu(Snu)
////	,u_a(){
////
////	}
////
////	inline void init(double a){
////		if(a<0.)	a	= 0.;
////		this->a	= a;
////		mp2_a_m	= pow_2(2.*a);
////	}
////
////	inline Var_Limit& limits_qT(Var_Limit &qT){
////		_set_1_M();
////		return qT.reduce(qT_a);
////	}
////
////	inline Var_Limit& limits_nu(Var_Limit &nu){
////		_set_3_y();
////		return nu.reduce(nu_a);
////	}
////
////	inline Var_Limit& limits_u(Var_Limit &u){
////		_set_4_nu();
////		return u.reduce(u_a);
////	}
////
////	inline virtual ~Cut_kT(){
////
////	}
////
////};
////
////class Cut_eta: public _Cut{
////protected:
////	double b,thb;
////
////	Var_Limit y_b;
////
////	double *lM2,*ly,*lT;
////	Var_Limit nu_b;
////
////	double *nu;
////	int sign_y_nu;
////	Var_Limit u_b;
////
////	template< int su >
////	inline double _nu_ub_pm(double thb)const{
////		double a( thb+(*ly) );
////		double b( 0.5*(*lM2)	 + (*ly)*a );
////		double c( 0.5*(*lM2)*thb - a );
////		a	*= (*lT);
////
////		//result= -( b*c + su* a* sqrt( a^2 + b^2 - c^2) )/( a^2 +b^2 )
////		//		= -(b * c/( a^2 +b^2 )	+ su* a* sqrt( 1/( a^2 +b^2 ) - (c/( a^2 +b^2 ))^2 ))
////		double tmp = 1./(pow_2(a) + pow_2(b));
////		//		= -(b * c*tmp	+ su* a* sqrt( tmp - (c*tmp)^2 ) )
////
////		c	*= tmp;
////		//		= -(b * c	+ su* a* sqrt( tmp - (c)^2 ) )
////
////		b	*= c;
////		//		= -(b + su* a* sqrt( tmp - (c)^2 ) )
////
////		a	*= sqrt( tmp-pow_2(c) );
////		//		= -(b	+ su* a)
////
////		return -(b + su*a);
////	}
////
////	inline double u_bp(double sthb)const{
////		return ( sthb-(*ly) )/( sthb-(*nu) );
////	}
////
////	inline virtual void _set_1_y(){
////		nu_b.set_min_max(-thb,+thb);
////
////		nu_b.choose_min_max(_nu_ub_pm<-1>(-thb),_nu_ub_pm<-1>(+thb));
////	}
////
////	inline virtual void _set_2_nu(){
////		sign_y_nu = _SIGN((*ly)-(*nu));
////		u_b.set_max(u_bp(sign_y_nu*thb));
////	}
////
////public:
////	inline Cut_eta(double *lM2, double *ly, double *lT, double *nu)
////	:_Cut()
////	,b(0.),thb(0.)
////	,lM2(lM2),ly(ly),lT(lT)
////	,nu_b()
////	,nu(nu)
////	,sign_y_nu(0)
////	,u_b(){
////
////	}
////
////	inline virtual void init(double b){
////		this->b	= b;
////		if(b>0){
////			thb	= tanh(b);
////			y_b.set_min_max(-b,+b);
////		}else{
////			thb	= +1.;
////			y_b.set_unvalid();
////		}
////		u_b.set_min(0.);
////	}
////
////	inline virtual Var_Limit& limits_y(Var_Limit &y){
////		if(y_b.valid()) y.reduce(y_b);
////		return y;
////	}
////
////	inline virtual Var_Limit& limits_nu(Var_Limit &nu){
////		_set_1_y();
////		return nu.reduce(nu_b);
////	}
////
////	inline virtual Var_Limit& limits_u(Var_Limit &u){
////		_set_2_nu();
////		return u.reduce(u_b);
////	}
////
////	inline virtual ~Cut_eta(){
////
////	}
////};
////
////class Exlude_eta: public Cut_eta {
////protected:
////	enum E_region {e_ll=0, e_l=1, e_c=2, e_r=3, e_rr=4, WRONG_REGION=5};
////	vector<double> region_limits;
////
////	double thb0,thb1;
////
////	E_region R_y;
////	vector<Ex_Limit> nu_excludes,nu_excludes_reduced;
////
////	E_region R_nu;
////
////
////	inline E_region _get_region(double val)const{
////		if( (val<-1.) || (val>1.) ){
////			cerr	<<"Exlude_eta::_get_region("<<val<<") -> Wrong region"<<endl;
////			return WRONG_REGION;
////		}
////		int i(0);
////		while( (i<5) && (val > region_limits[i]) ) ++i;
////		return static_cast<E_region>(i);
////	}
////
////	inline vector<Ex_Limit>& _reduce(vector<Ex_Limit>& to_reduce, int n, int N)const{
////		for(int i=N-1; i>=n; --i){
////			if(!to_reduce[i].valid()){
////				if(i<N-1) std::swap(to_reduce[i],to_reduce[N-1]);
////				--N;
////				to_reduce.resize(N);
////			}
////		}
////		for(int i=N-1; i>=n; --i){
////			for(int j=0; j<i; ++j){
////				if(to_reduce[j].reduce(to_reduce[i])){
////					if(i<N-1) std::swap(to_reduce[i],to_reduce[N-1]);
////					--N;
////					to_reduce.resize(N);
////				}
////			}
////		}
////		return to_reduce;
////	}
////
////	inline Var_Limit& _reduce(Var_Limit& var, vector<Ex_Limit>& to_reduce)const{
////		int N(to_reduce.size());
////
////		for(int i=N-1; i>=0; --i){
////			if(var.reduce(to_reduce[i])){
////				if(i<N-1) std::swap(to_reduce[i],to_reduce[N-1]);
////				--N;
////				to_reduce.resize(N);
////			}
////		}
////		return var;
////	}
////
////
////	inline void _set_nu_excludes(){
////		int N(4);
////		nu_excludes.resize(N);
////		nu_excludes[0].set_min_max(-thb1,-thb0);
////		nu_excludes[1].set_min_max(thb0,thb1);
////		switch (R_y) {
////			case e_c:
////				nu_excludes[2].set_min_max(_nu_ub_pm<+1>(-thb1),_nu_ub_pm<-1>(-thb0));
////				nu_excludes[3].set_min_max(_nu_ub_pm<-1>(+thb0),_nu_ub_pm<+1>(+thb1));
////				break;
////			case e_r:
////				nu_excludes[2].set_min_max(_nu_ub_pm<+1>(-thb1),_nu_ub_pm<+1>(-thb0));
////				nu_excludes[3].set_min_max(_nu_ub_pm<-1>(+thb0),_nu_ub_pm<+1>(+thb1));
////				break;
////			case e_rr:
////				nu_excludes[2].set_min_max(_nu_ub_pm<-1>(-thb1),_nu_ub_pm<+1>(-thb0));
////				nu_excludes[3].set_min_max(_nu_ub_pm<-1>(+thb0),_nu_ub_pm<+1>(+thb1));
////				break;
////			case e_l:
////				nu_excludes[2].set_min_max(_nu_ub_pm<+1>(-thb1),_nu_ub_pm<-1>(-thb0));
////				nu_excludes[3].set_min_max(_nu_ub_pm<+1>(+thb0),_nu_ub_pm<+1>(+thb1));
////				break;
////			case e_ll:
////				nu_excludes[2].set_min_max(_nu_ub_pm<+1>(-thb1),_nu_ub_pm<-1>(-thb0));
////				nu_excludes[3].set_min_max(_nu_ub_pm<+1>(+thb0),_nu_ub_pm<-1>(+thb1));
////				break;
////			default:
////				break;
////		}
////		_reduce(nu_excludes,2,N);
////
////	}
////
////	inline void _set_1_y(){
////		Cut_eta::_set_1_y();
////		R_y	= _get_region(*ly);
////		_set_nu_excludes();
////	}
////
////	inline void _set_2_nu(){
////		Cut_eta::_set_2_nu();
////		R_nu= _get_region(*nu);
////	}
////
////	inline void _init(){
////		region_limits[0]	= -thb1;
////		region_limits[1]	= -thb0;
////		region_limits[2]	= +thb0;
////		region_limits[4]	= +thb1;
////
////	}
////
////public:
////	inline Exlude_eta(double *lM2, double *ly, double *lT, double *nu)
////	:Cut_eta(lM2,ly,lT,nu)
////	,region_limits(vector<double>(4,0.))
////	,thb0(1.),thb1(1.)
////	,R_y()
////	,nu_excludes(vector<Ex_Limit>(4,Ex_Limit()))
////	,nu_excludes_reduced(vector<Ex_Limit>(4,Ex_Limit()))
////	,R_nu(){
////
////	}
////
////	inline void init(double b){
////		Cut_eta::init(b);
////
////		thb0	= 1.;
////		thb1	= 1.;
////
////		_init();
////	}
////
////	inline void init(double b, double b0, double b1){
////		Cut_eta::init(b);
////
////		thb0	= tanh(b0);
////		thb1	= tanh(b1);
////
////		_init();
////	}
////
////	inline Var_Limit& limits_nu(Var_Limit &nu){
////		_set_1_y();
////		nu.reduce(nu_b);
////		return _reduce(nu,nu_excludes);
////	}
////
////};
////
////class _Coord{
////protected:
////	_Coord *additional_Coord;
////	double _coord;
////	double _Jac;
////
////	inline _Coord()
////	:additional_Coord(NULL)
////	,_coord(0.),_Jac(0.){
////
////	}
////
////	inline ~_Coord(){
////
////	}
////
////
////	inline virtual double v_set_Coord(const double* xx);
////
////public:
////	virtual double get_Jac();
////
////	inline double get_Coord(double* xx, int additional_dims=0){
////		v_set_Coord(xx);
////		if(additional_dims>0){
////			_Jac *= additional_Coord->get_Jac();
////			additional_Coord->get_Coord(++xx,--additional_dims);
////		}
////		return _coord;
////	}
////
////};
////
////class Coord_u:public _Coord {
////protected:
////	double *up,*um;
////
////public:
////	double u_min,u_max;
////
////protected:
////
////	inline double v_set_Coord(const double* xx){
////		_coord	= u_min + (*xx)*_Jac;
////		return _coord;
////	}
////
////public:
////
////	inline Coord_u()
////	:_Coord()
////	,up(NULL),um(NULL)
////	,u_min(0.),u_max(0.){
////
////	}
////
////	inline virtual ~Coord_u(){
////
////	}
////
////	inline void init(double* up, double* um){
////		this->up	= up;
////		this->um	= um;
////
////	}
////
////
////	inline double get_Jac(){
////		u_min	= *um;
////		u_max	= *up;
////
////		_Jac	= u_max-u_min;
////
////		return _Jac;
////	}
////};


class Rapidity_Limits{
protected:
	double M2;

	double y_cut;
	bool ex;
	double y_ex0,y_ex1;

	Variable_Exclusion E_ym;
	Variable_Exclusion E_yp;


	Two_P_PS_Interpolated two_p_ps_I;

public:
	Variable_Limit L_mp;//(S,M,a)
	Variable_Limit L_y;//(qT,b)

	double y;
	double Jac_y;//(qT,y)

protected:

	inline void _init(const double sqrtS, const double M, const double mp_min){
		M2		= pow_2(M);
		y_cut	= -1.;
		y_ex0	= -1.;
		y_ex1	= -1.;
		ex = false;

		const double mp_max		= (sqrtS*sqrtS+M2)/(2.*sqrtS);
		L_mp.init_min_max(mp_min,mp_max);
	}

	inline void _init(const double sqrtS, const double M,const double mp_min, const double y_cut, const double y_ex0, const double y_ex1){
		_init(sqrtS,M,mp_min);

		if(0<y_cut)	this->y_cut	= y_cut;

		if( (0<=y_ex0) && (y_ex0<y_ex1)){
			ex = true;
			this->y_ex0	= y_ex0;
			this->y_ex1	= y_ex1;
		}
	}

	inline double _set0(){
		Jac_y = 0.;
		return 0.;
	}

	inline bool _set_Ly_get_valid(const double qT){
		const double mp(sqrt(M2+qT*qT));

		if(L_mp.position_of(mp)!=V_I_inside){
			L_y.set_unvalid();
		}else{
			const double tmp(acosh(L_mp.max/mp));
			L_y.init_min_max(-tmp,+tmp);
			if(0<y_cut) L_y.add_limit_min_max(-y_cut,+y_cut);

			if(ex){
				if(0.==y_ex0){
					E_yp.init_min_max(-y_ex1,y_ex1);
					E_ym.set_unvalid();
				}else{
					E_yp.init_min_max(+y_ex0,+y_ex1);
					E_ym.init_min_max(-y_ex1,-y_ex0);
				}

				E_yp.apply_to_limit(L_y);
				E_ym.apply_to_limit(L_y);
			}
		}
		return L_y.is_valid();
	}

public:
	inline void init(const double sqrtS, const double M){
		const double mpmin = two_p_ps_I.init_and_return_min_mp(M);
		_init(sqrtS,M,M);
	}

	inline void init(const double sqrtS, const double M, const OPS_Cuts &op){
		const double mpmin = two_p_ps_I.init_and_return_min_mp(M,op);

		y_cut	= -1.;
		y_ex0	= -1.;
		y_ex1	= -1.;

		if(op.abs_y_max.is_set){
			y_cut	= op.abs_y_max();
		}

		if(op.abs_y_exclude.is_set){
			y_ex0	= op.abs_y_exclude[0];
			y_ex1	= op.abs_y_exclude[1];
		}

		_init(sqrtS,M,mpmin,y_cut,y_ex0,y_ex1);
	}

	inline bool set_qT(const double qT){
//		cout	<<"->Rapidity_Limits::set_qT()"<<endl;
		if(_set_Ly_get_valid(qT)){
			L_y	= two_p_ps_I.update_qT_get_ipol_range(qT,L_y);
		}
		return L_y.is_valid();
	}

	inline double update_qT_y_get_Jac(const double qT, const double y){
		this->y	= y;
		if(!_set_Ly_get_valid(qT)) return _set0();

		if(!y_is_valid(y)) return _set0();

		Jac_y	= two_p_ps_I.get_calculated_Jac(qT,y);

		return Jac_y;
	}

	inline double update_y_get_Jac(const double xx[1]){
		if(L_y.is_unvalid()) return _set0();

		double min(L_y.min);
		double max(L_y.max);

		if(ex){
			if(E_ym.is_valid())	min += E_ym.size();
			if(E_yp.is_valid())	max -= E_yp.size();
		}

		y	= min + xx[0]*(max-min);

		if(ex){
			if(E_yp.is_valid() && (E_yp.position_of(y) != V_I_left))
				y += E_yp.size();
			if(E_ym.is_valid() && (E_ym.position_of(y) != V_I_right))
				y -= E_ym.size();
		}

		Jac_y	= (max-min)*two_p_ps_I.get_interpolated_Jac(y);

		return Jac_y;
	}

	inline Rapidity_Limits()
	:M2()
	,y_cut()
	,ex(),y_ex0(),y_ex1()
	,E_yp(),E_ym()
	,two_p_ps_I()
	,L_mp(),L_y()
	,y(),Jac_y(){

	}

	inline bool y_is_valid(const double y)const{
		return (L_y.contains(y) && ( !ex || (!( E_yp.contains(y) || E_ym.contains(y) )) ) );
	}

};

class ZZ_Limits {
public:
	Variable_Limit limits[2];
	double Jac;

	inline double set_xi_pm(const double xi_pm[2]){
		limits[0].init_min(xi_pm[0]);
		limits[1].init_min(xi_pm[1]);
		Jac	= limits[0].size()*limits[1].size();
		return (Jac);
	}

	inline bool update_zz_get_OK(double zz[2], const double xx[2]){
		zz[0]	= limits[0].get_value_linear_reversed(*xx);
		zz[1]	= limits[1].get_value_linear_reversed(*(++xx));
		return (Jac>0.);
	}

	inline bool ok(const double zz[2]){
		return ((limits[0].contains(zz[0]))&&(limits[1].contains(zz[1])));
	}

	ZZ_Limits()
	:limits(),Jac(0.){
		limits[0].init_max(1.);
		limits[1].init_max(1.);
	}

};




class Plus_x2{
protected:
	double ix2;		// 1./x2
	double ix2lx2;	// log(x2/const)

	double RJp;
	double RJd;
	double G0;
	double G1;

public:
	inline void set_Jacs(double RJp=1., double RJd=1.){
		this->RJp	= RJp;
		this->RJd	= RJd;
	}
	inline void set_Gs(double G0=0., double G1=0.){
		this->G0	= G0;
		this->G1	= G1;
	}
	inline void set_x2(double ix2, double lx2=0.){
		this->ix2		= ix2;
		this->ix2lx2	= ix2*lx2;
	}

	inline double delta(double f0d, double finite=0.)const{
		return ( f0d*RJd + finite);
	}

	inline double PD0(double fx0, double f00, double finite=0.)const{
		return ( (fx0-RJp*f00)*ix2 + f00*RJd*G0 + finite);
	}

	inline double PD1(double fx1, double f01, double finite=0.)const{
		return ( (fx1-RJp*f01)*ix2lx2 + f01*RJd*G1 + finite);
	}

	inline double of(double f0d, double fx0, double f00, double fx1, double f01, double finite)const{
		return delta(f0d) + PD0(fx0,f00) + PD1(fx1,f01) + finite;
	}

	inline double operator()(double f0d, double fx0, double f00, double fx1, double f01, double finite)const{
		return of(f0d,fx0,f00,fx1,f01,finite);
	}

	Plus_x2()
	:ix2(0.),ix2lx2(0.)
	,RJp(1.),RJd(1.)
	,G0(0.),G1(0.){

	}
};

class XIXI_Limits;

class STUX2 {
	friend class XIXI_Limits;
public:
	double S,T,U,X2;
	double M2,lT2;
	const double *xi_pm;
	double xi[3],xi0[3];
	double s,t,u,x2;
	double s0,t0,u0,x20;

	double Jac,Jac0,R_J0iJ;
	Plus_x2 plus_x2_A;
	Plus_x2 plus_x2_X2;

protected:

	inline double _x2_xx(double xi, double xib)const{
		return S*((xi-xi_pm[0])*(xib-xi_pm[1]) - lT2*xi_pm[0]*xi_pm[1]);
	}

	inline double _x2_xx(double xixib[2])const{
		return _x2_xx(xixib[0],xixib[1]);
	}

	inline void set_STUX2(double lT2){
		this->lT2	= lT2;
//		qT2 =-_x2_xx(xi+,xi-);
		M2	= _x2_xx(0.,0.);
		T	= _x2_xx(1.,0.);
		U	= _x2_xx(0.,1.);
		X2	= _x2_xx(1.,1.);
	}

	inline void set_stux2(){
		xi[2]	= xi[0]*xi[1];

		s	= S*xi[2];
		t	= _x2_xx(xi[0],  0. );
		u	= _x2_xx(  0. ,xi[1]);
		x2	= _x2_xx(xi[0],xi[1]);

		xi0[2]	= xi0[0]*xi0[1];

		s0	= S*xi0[2];
		t0	= _x2_xx(xi0[0],  0.  );
		u0	= _x2_xx(  0.  ,xi0[1]);
		x20	= 0.;//_x2_xx(xi0[0],xi0[1]);

		if(x2<0.){
			//FIXME
			x2=0.;
			plus_x2_A.set_x2(0.);
			plus_x2_X2.set_x2(0.);
		}else{
			plus_x2_A.set_x2(1./x2,log(x2/M2));
			plus_x2_X2.set_x2(1./x2,log(x2/X2));
		}

	}

public:

	inline void init(double S){
		this->S	= S;
	}

	STUX2(const double xi_pm[2])
	:S(),T(),U(),X2()
	,M2(),lT2()
	,xi_pm(xi_pm)
	,xi(),xi0()
	,s(),t(),u(),x2()
	,s0(),t0(),u0(),x20()
	,Jac(),Jac0(),R_J0iJ()
	,plus_x2_A(),plus_x2_X2(){

	}

	inline const string to_String(int ntabs=0)const{
		stringstream ss;
		for(int i=0; i<ntabs; ++i) ss<<"\t";
		string tab(ss.str());
		ss.str(string());

		ss<<tab	<<"STUX2:"<<endl;
		ss<<tab	<<"\t"<<"sS="<<sqrt(S)	<<"\t"<<"T="<<T	<<"\t"<<"U="<<U	<<"\t"<<"X2="<<X2	<<endl;
		ss<<tab	<<"\t"<<"M="<<sqrt(M2)	<<"\t"<<"lT2="<<lT2	<<endl;
		ss<<tab	<<"\t"<<"xi_pm=["<<xi_pm[0]<<","<<xi_pm[1]<<"]"	<<endl;
		ss<<tab	<<"\t"<<"   xi=["<<xi[0]<<","<<xi[1]<<","<<xi[2]<<"]"	<<endl;
		ss<<tab	<<"\t"<<"  xi0=["<<xi0[0]<<","<<xi0[1]<<","<<xi0[2]<<"]"	<<endl;
		ss<<tab	<<"\t"<<"s="<<s	<<"\t"<<"t="<<t	<<"\t"<<"u="<<u	<<"\t"<<"x2="<<x2	<<endl;
		ss<<tab	<<"\t"<<"s0="<<s0	<<"\t"<<"t0="<<t0	<<"\t"<<"u0="<<u0	<<"\t"<<"x20="<<x20	<<endl;
		ss<<tab	<<"\t"<<"Jac="<<Jac	<<"\t"<<"Jac0="<<Jac0	<<"\t"<<"R_J0iJ="<<R_J0iJ	<<endl;

		return ss.str();
	}
};


class XIXI_Limits {
protected:
	STUX2 *p;
	double *xi,*xi0;
	const double *xi_pm,*lT2;
public:
#ifdef WITH_RAYS
	double Delta_T,lDT;
	#ifdef WITH_DP
	double m0,m,rm_pm[2],r_pm[2];
	#endif
#else
	double B,C,A;
	#ifdef LINEAR_XI0

	#else
		#ifdef LOG_XI0
	double lxi0min,lxi0delta;
		#endif
	#endif
#endif

protected:

#ifdef WITH_RAYS
	#ifdef WITH_R2PS

	inline void _r_pm(double r_pm[2], double ms, double r2p)const{
		r_pm[1]	= 0.5*(1.+ms) - sqrt( pow_2(0.5*(1.-ms)) + ms*r2p );
		ms		= 1./ms;
		r_pm[0]	= 0.5*(1.+ms) - sqrt( pow_2(0.5*(1.-ms)) + ms*r2p );
	}

	inline double _Jac_r2ps(double ms, const double r_pm[2])const{
		return ( r_pm[0]*(1.+pow_2(ms))*(1.-xi_pm[0])*(1.-xi_pm[1]) )/(ms+1.-2.*r_pm[1]);
	}

	inline double _Jac_r2ps(double ms, double r2p)const{
		double r_pm[2];
		_r_pm(r_pm, ms, r2p);
		return _Jac_r2ps(ms,r_pm);
	}

	inline double _xixib(double xi[2], double ms, double r2p)const{
		double r_pm[2];
		_r_pm(r_pm, ms, r2p);

		xi[0]	= 1.-(1.-xi_pm[0])*r_pm[0];
		xi[1]	= 1.-(1.-xi_pm[1])*r_pm[1];

		return _Jac_r2ps(ms,r_pm);
	}

	inline void _r2ps(const double xx[2], const double zz[2]=NULL, double Jac_z=0.){
		double r2p,ms;
		#ifdef WITH_R2PS_LINEAR
		r2p		= Delta_T + xx[0]*(1.-Delta_T);
		ms		= tan(xx[1]*M_PI_2);
		p->Jac	= (1.-Delta_T)*M_PI_2;
		#else
			#ifdef WITH_R2PS_LOG
			r2p		= exp(lDT-xx[0]*lDT);
			ms		= tan(xx[1]*M_PI_2);
			p->Jac	= -lDT*r2p*M_PI_2;
			#else
			double x0(xi_pm[0]/zz[0]);
			double x1(xi_pm[1]/zz[1]);
			double r_pm[2];
			r_pm[0]	= (1.-x0)/(1.-xi_pm[0]);
			r_pm[1]	= (1.-x1)/(1.-xi_pm[1]);
			r2p		= (1.-r_pm[0])*(1.-r_pm[1]);
			ms		= r_pm[1]/r_pm[0];
				#ifdef WITH_R2PS_ZZ
				r2p		= Delta_T + r2p*(1.-Delta_T);
				p->Jac	= (1.-Delta_T);
				#else
				r2p		= exp(lDT-r2p*lDT);
				p->Jac	= (-lDT*r2p);
				#endif
			p->Jac	*= Jac_z*(x0/zz[0])*(x1/zz[1])/_Jac_r2ps(ms,r_pm);
			#endif	//WITH_R2PS_LOG
		#endif



		p->Jac0	= p->Jac;

		double Jx2	= _xixib(xi ,ms,    r2p);
		double J0	= _xixib(xi0,ms,Delta_T);

		p->set_stux2();

		p->Jac		*= Jx2/xi[2];
		double RJp	 = (J0/Jx2) * (xi[2]/xi0[2]);
		p->R_J0iJ	 = (1./p->X2) * RJp;
		p->Jac0		*= (J0) * (1./p->X2) * (1./xi0[2]);

		double fA	= log(p->S/p->M2*(xi0[0]-xi_pm[0])*(1.-xi0[1]));
		double fX2	= log(p->X2/p->M2);

		double G0	= -(fA-fX2);
		double G1	= -0.5*(fA*fA-fX2*fX2);

		p->plus_x2_A.set_Jacs(RJp,p->R_J0iJ);
		p->plus_x2_A.set_Gs(G0,G1);


		p->plus_x2_X2.set_Jacs(RJp,p->R_J0iJ);
		p->plus_x2_X2.set_Gs();

	}
	#endif	//WITH_R2PS

	#ifdef WITH_DP
	inline double _f_r_pm(double rm)const{
		return 0.5*(1.+rm) - sqrt( pow_2(0.5*(1.-rm)) + rm*Delta_T );
	}

	inline double _dist_iS_d_x2_d_dist(const double xi[2])const{
		return ( (1.-xi[0])*(xi[1]-xi_pm[1]) + (xi[0]-xi_pm[0])*(1.-xi[1]) );
	}

	inline void ray(const double zz[2], double Jac_z){
		double x0(xi_pm[0]/zz[0]);
		double x1(xi_pm[1]/zz[1]);

		m		= (1.-x1)/(1.-x0);

		rm_pm[0]= m0/m;
		rm_pm[1]= m/m0;

		r_pm[0]	= _f_r_pm(rm_pm[0]);
		r_pm[1]	= _f_r_pm(rm_pm[1]);

		//		double r = (r_pm[0]>r_pm[1]) ? (r_pm[0]) : (r_pm[1]);
		double r = (m0>m) ? (r_pm[0]) : (r_pm[1]);

		xi[0]	= 1. - r * (1.-x0);
		xi[1]	= 1. - r * (1.-x1);

		xi0[0]	= 1. - r_pm[0] * (1.-xi_pm[0]);
		xi0[1]	= 1. - r_pm[1] * (1.-xi_pm[1]);

		p->set_stux2();

		p->Jac		= (r*r * Jac_z * x0/zz[0] * x1/zz[1])/xi[2];
		p->R_J0iJ	= 2./(p->S*_dist_iS_d_x2_d_dist(xi0))*xi[2]/xi0[2];
		p->Jac0		= p->Jac*p->R_J0iJ;

//		Jac_xi[0]	= r * Jac_z[0] * x0/zz[0];
//		Jac_xi[1]	= r * Jac_z[1] * x1/zz[1];
//		Jac_xi[2]	= Jac_xi[0]*Jac_xi[1];

//		Jac_xi_delta_x2	= Jac_xi[2]*2./(S*_dist_iS_d_x2_d_dist(xi0));

//		Pre_delta_x2	= 2./(S*_dist_iS_d_x2_d_dist(xi0));
		double RJp	= _dist_iS_d_x2_d_dist(xi)/_dist_iS_d_x2_d_dist(xi0);
		RJp			*=( xi[2]*(1.-xi0[0])*(1.-xi0[1]) )/( xi0[2]*(1.-xi[0])*(1.-xi[1]) );

		double fA	= log(p->S/p->M2*(xi0[0]-xi_pm[0])*(1.-xi0[1]));
		double fX2	= log(p->X2/p->M2);

		double G0	= -(fA-fX2);
		double G1	= -0.5*(fA*fA-fX2*fX2);

		p->plus_x2.set_Jacs(RJp,p->R_J0iJ);
		p->plus_x2.set_Gs(G0,G1);
	}
	#endif	//WITH_DP
#endif	//WITH_RAYS
public:

	inline void set_y(double lT2){
		p->set_STUX2(lT2);
#ifdef WITH_RAYS
		Delta_T	= lT2*xi_pm[0]*xi_pm[1]/((1.-xi_pm[0])*(1.-xi_pm[1]));
		lDT		= log(Delta_T);
	#ifdef WITH_DP
		m0		= (1.-xi_pm[1])/(1.-xi_pm[0]);
	#endif	//WITH_DP
#else	//WITH_RAYS
		B	= xi_pm[1]/(1.-xi_pm[1]);
		B	= xi_pm[0]*(1.+(lT2)*B);
	#ifdef LINEAR_XI0

	#else
		#ifdef LOG_XI0
		lxi0min	=	log(B -xi_pm[0]);
		lxi0delta=	log(1.-xi_pm[0])-lxi0min;
		#endif
	#endif
#endif	//WITH_RAYS
	}

	inline double update_xi_get_OK(const double xx[2], const double zz[2]=NULL, double Jac_z=0.){
#ifdef WITH_RAYS
	#ifdef WITH_R2PS
		_r2ps(xx,zz,Jac_z);
	#endif
	#ifdef WITH_DP
		ray(zz,Jac_z);
	#endif
#else
	#ifdef LINEAR_XI0
		xi[0]	= B + xx[0]*(1.-B);
		xi0[0]	= xi[0];
		p->Jac	= (1.-B);	// D[xi[0],xx]
	#else
		#ifdef LOG_XI0
		double el	= exp(lxi0min + xx[0]*lxi0delta);

		xi[0]		= el + xi_pm[0];
		xi0[0]		= xi[0];

		p->Jac		= lxi0delta*el;	// D[xi[0],xx]
		#endif
	#endif
	#ifdef LINEAR_XI1

		if(xi[0]<=B) return false;

//		NS_Utils::DOUT dout("XIXI_Limits::update_xi_get_Jac","LINEAR_XI1");
		C	= xi_pm[0]/(xi[0]-xi_pm[0]);
		C	= xi_pm[1]*(1.+(*lT2)*C);
		if(C>=1.){
			C		= 1.;
			A		= 0.;
			xi[1]	= C;
			xi0[1]	= C;

			p->set_stux2();
			p->Jac0	= 0.;

			cerr	<<"NAN C>=1.\tJac="<<p->Jac<<endl;
			cerr	<<p->to_String(2)<<endl;
			cerr	<<"\t\txi0-B = "<<xi[0]-B<<endl;
		}else{
			A		= (p->S)*(xi[0]-xi_pm[0])*(1.-C);
			xi[1]	= C + xx[1]*(1.-C);
			xi0[1]	= C;

			p->set_stux2();
//			p->Jac0	= p->Jac*(1.-C)/(xi0[2]*A);
			p->Jac0	= p->Jac/(xi0[2]*(p->S)*(xi[0]-xi_pm[0]));
		}



//		dout()<<"xx[1]="<<xx[1]	<<"\t"<<"A="<<A	<<"\t"<<"C="<<C		<<"\t"<<"xi[1]="<<xi[1]	<<endl;

		if(p->Jac0!=p->Jac0){
			cerr	<<"***************************************************************"<<endl
					<<"**** NAN XIXI_Limits::update_xi_get_OK Jac0"<<endl
					<<"**** xi =["<<xi[0]<<","<<xi[1]<<"] out of range"<<endl
					<<"**** xi0=["<<xi0[0]<<","<<xi0[1]<<"] out of range"<<endl
					<<"**** A="<<A<<"B="<<B<<"\tC="<<C<<endl
					<<"**** A==0"<<(A==0)<<"\tC==1"<<(C==1)<<endl
					<<"**** Cuba.xx=["<<xx[0]<<","<<xx[1]<<"]"<<endl
					<<"***************************************************************"<<endl;
		}
		p->Jac	*= (1.-C)/xi[2];	// D[xi,x0]*D[xib,x1] /(xi*xib)

		double RJp		= xi[2]/xi0[2];
		p->R_J0iJ		= RJp/A;

		p->plus_x2_A.set_Jacs(RJp,p->R_J0iJ);
		p->plus_x2_A.set_Gs(0.,0.);

		double lAX2	= log(A/p->X2);

		p->plus_x2_X2.set_Jacs(RJp,p->R_J0iJ);
		p->plus_x2_X2.set_Gs(lAX2,0.5*lAX2*lAX2);
	#endif
#endif
		if((B<xi[0])&&(xi[0]<=1.)&&(C<=xi[1])&&(xi[1]<=1.)){
			return true;
		}else{
			cerr	<<"***************************************************************"<<endl
					<<"**** XIXI_Limits::update_xi_get_OK(xx,zz,Jac)"<<endl
					<<"**** xi =["<<xi[0]<<","<<xi[1]<<"] out of range"<<endl
					<<"**** xi0=["<<xi0[0]<<","<<xi0[1]<<"] out of range"<<endl
					<<"**** B="<<B<<"\tC="<<C<<endl
					<<"**** Cuba.xx=["<<xx[0]<<","<<xx[1]<<"]"<<endl
					<<"***************************************************************"<<endl;
			return false;
		}
	}

	XIXI_Limits(STUX2 &p)
	:p(&p),xi(p.xi),xi0(p.xi0),xi_pm(p.xi_pm),lT2(&p.lT2)
#ifdef WITH_RAYS
	,Delta_T()
	#ifdef WITH_DP
	,m0()
	,m(),rm_pm(),r_pm()
	#endif
#else
	,B(),C(),A()
	#ifdef LINEAR_XI0

	#else
		#ifdef LOG_XI0
	,lxi0min(),lxi0delta()
		#endif
	#endif
#endif
	{

	}

};


class Kinematics {
protected:
	static const double epsilon=(1e-6);
public:
	double S,sS;

	Variable_Limit M_Limits;
	double M,M2;

	Variable_Limit qT_Limits;
	double qT,qT2;
	double mT,mT2;	// mT2 = M2 + qT2
	double lT2;		// = qT2/mT2
	double tau;		// = mT/sS

	Rapidity_Limits y_Limits;
	double y,e_pm_y[2];	// e_pm_y[0]= e^(+y) // e_pm_y[1] = e^(-y)
	double Jac_y;
	double xi_pm[2];// xi_pm[0] = mT/sS E^(+y) // xi_pm[1] = mT/sS E^(-y)

//	double T,U,X2;

	ZZ_Limits z_Limits;
	double z[2];
//	double x[2];
	double Jac_z;

	STUX2 stux2;
	XIXI_Limits xi_Limits;

//	double xi[3];	// = [xi,xib,xi*xib]
//	double xi0[3];
//	double Jac_xi;
//	Plus_x2 plus_x2;
//
//	double A,B,C;	// B=min[xi[0]]	// C(xi[0])=min[xi[1]](xi[0])	// A(xi[0])=max[x2[1]](xi[0])
//	double s,t,u,x2;
//	double s0,t0,u0,x20;

protected:

	inline void _set_sS(){
		S		= sS*sS;

		M_Limits.init_min_max(0.,sS);

		stux2.init(S);
	}

	inline void _set_M(){
		M2		= M*M;
		qT_Limits.init_min_max(0., (S-M2)/(2.*sS) );
	}

	inline void _init(const double sS, const double M){
		this->sS	= sS;
		this->M		= M;
		_set_sS();
		_set_M();
	}

	inline void _set_qT(const double qT){
		this->qT= qT;
//		cout	<<"Kinematics::_set_qT()"<<endl;
		qT2		= qT*qT;
		mT2		= qT2+M2;
		mT		= sqrt(mT2);
		lT2		= qT2/mT2;
		tau 	= mT/sS;
	}


	inline bool _set_y(){
//		cout	<<"->	Kinematics_q_X::_set_y()"	<<endl;
		Jac_y	= y_Limits.Jac_y;
		y		= y_Limits.y;

		if(Jac_y>0.){
			e_pm_y[0]	= exp(+y);
			e_pm_y[1]	= 1./e_pm_y[0];

			xi_pm[0]	= tau*e_pm_y[0];
			xi_pm[1]	= tau*e_pm_y[1];

			for(int i=0; i<=1;++i) if( (0.>=xi_pm[i]) || (xi_pm[i]>=1.) ){
				cerr	<<"***************************************************************"<<endl
						<<"**** Kinematics::_set_y()"<<endl
						<<"**** xi^\\pm =["<<xi_pm[0]<<","<<xi_pm[1]<<"] out of range"<<endl
						<<"**** y="<<y<<"\ttau="<<tau<<endl
						<<"***************************************************************"<<endl;
				Jac_y	= -1.;
				return false;
			}

			z_Limits.set_xi_pm(xi_pm);
			xi_Limits.set_y(lT2);

			return true;
		}else{
			return false;
		}
	}

	inline bool _set_z(const double xx[2]){
		for(int i=0; i<2; ++i){
//			if(1.==z[i]){
//				z[i]*=(1.-epsilon);
//				cerr<<"z"<<endl;
//				return _set_z(xx);
//			}else if(z[i]==xi_pm[i]){
//				z[i]*=(1.+epsilon);
//				cerr<<"z"<<endl;
//				return _set_z(xx);
//			}
			if( (z[i]<=xi_pm[i]) || (1.<=z[i]) ){
				cerr	<<"***************************************************************"<<endl
						<<"**** Kinematics::_set_z(x[i] = "<<xx[i]<<"==1 ? "<<(xx[i]==1.)<<")"<<endl
						<<"**** z["<<i<<"] = "<<z[i]<<" out of range ("<<xi_pm[i]<<","<<"1)"<<endl
						<<"**** y = "<<y<<"\txipm =["<<xi_pm[0]<<","<<xi_pm[1]<<"]"<<endl
						<<"***************************************************************"<<endl;
				return false;
			}
		}
		for(int i=0; i<2; ++i){
			const double xi_i(xi_pm[i]/z[i]);
			if( (xi_i<=xi_pm[i]) || (1.<=xi_i) ){
				cerr	<<"***************************************************************"<<endl
						<<"**** Kinematics::_set_z()"<<endl
						<<"**** xi_"<<i<<" = "<<xi_i<<" out of range ("<<xi_pm[i]<<","<<"1)"<<endl
						<<"**** z["<<i<<"] ="<<z[i]<<"==1 ?"<<(z[i]==1.)<<endl
						<<"**** y = "<<y<<"\txipm =["<<xi_pm[0]<<","<<xi_pm[1]<<"]"<<endl
						<<"***************************************************************"<<endl;
				return false;
			}
		}
//		for(int i=0; i<2; ++i){
//			x[i]	= xi_pm[i]/z[i];
//			if( (xi_pm[i]>=x[i]) || (x[i]>=1.) ){
//				cerr	<<"***************************************************************"<<endl
//						<<"**** Kinematics::_set_z()"<<endl
//						<<"**** x =["<<x[0]<<","<<x[1]<<"] out of range"<<endl
//						<<"**** z =["<<z[0]<<","<<z[1]<<"]"<<endl
//						<<"**** xipm =["<<xi_pm[0]<<","<<xi_pm[1]<<"]"<<endl
//						<<"**** y ="<<y<<endl
//						<<"***************************************************************"<<endl;
//				return false;
//			}
//		}
		return true;
	}

//	inline double _x2_xx(double xi, double xib)const{
//		return ( S*((xi-xi_pm[0])*(xib-xi_pm[1])) -qT2 );
////		return S*((xi-xi_pm[0])*(xib-xi_pm[1]) - lT2*xi_pm[0]*xi_pm[1]);
//	}
//
//	inline double _x2_xx(double xixib[2])const{
//		return _x2_xx(xixib[0],xixib[1]);
//	}
//
//	inline void _set_stux2(){
//		xi[2]	=  xi[0]* xi[1];
//		xi0[2]	= xi0[0]*xi0[1];
//
//		s	= S*xi[2];
//		t	= _x2_xx(xi[0],  0. );//-S*xi_pm[1]*(xi[0]-(1.-lT2)*xi_pm[0]);	//M2 - (M2 - T)*xi[0];
//		u	= _x2_xx(  0. ,xi[1]);//-S*xi_pm[0]*(xi[1]-(1.-lT2)*xi_pm[1]);	//M2 - (M2 - U)*xi[1];
//		x2	= _x2_xx(xi);//S*((xi[0]-xi_pm[0])*(xi[1]-xi_pm[1])-lT2*xi_pm[0]*xi_pm[1]);//	s + t + u - M2
//
//		s0	= S*xi0[2];
//		t0	= _x2_xx(xi0[0],  0.  );//-S*xi_pm[1]*(xi0[0]-(1.-lT2)*xi_pm[0]);	//M2 - (M2 - T)*xi0[0];
//		u0	= _x2_xx(  0.  ,xi0[1]);//-S*xi_pm[0]*(xi0[1]-(1.-lT2)*xi_pm[1]);	//M2 - (M2 - U)*xi0[1];
//		//FIXME debug
//		x20	= _x2_xx(xi0);//0.;//	s0 + t0 + u0 - M2;
//
//		plus_x2.set_x2(1./x2,log(x2/M2));
//
////		//FIXME debug
////		if(x20!=0.) cout	<<"x20 = "<<x20	<<" = "<<s0+t0+u0-M2	<<endl;
//	}
//
//	inline void _update_xixib(const double xx[2]){
//#ifndef WITH_RAYS
//		B	= xi_pm[1]/(1.-xi_pm[1]);
//		B	= xi_pm[0]*(1.+lT2*B);
//#ifdef LINEAR_XI0
//		xi[0]	= B + xx[0]*(1.-B);
//		xi0[0]	= xi[0];
//
//		Jac_xi			= (1.-B);	// D[xi[0],xx]
//#else
//	#ifdef LOG_XI0
//		double lxi0min	=	log(B -xi_pm[0]);
//		double lxi0delta=	log(1.-xi_pm[0])-lxi0min;
//		double el		= exp(lxi0min + xx[0]*lxi0delta);
//
//		xi[0]			= el + xi_pm[0];
//		xi0[0]			= xi[0];
//
//		Jac_xi			= lxi0delta*el;	// D[xi[0],xx]
//	#endif
//#endif
//
//
//
//		C	= xi_pm[0]/(xi[0]-xi_pm[0]);
//		C	= xi_pm[1]*(1.+lT2*C);
//
//		A	= S*(xi[0]-xi_pm[0])*(1.-C);
//
//		xi[1]	= C + xx[1]*(1.-C);
//		xi0[1]	= C;
//
//		_set_stux2();
//
//		Jac_xi			*= (1.-C)/xi[2];	// D[xi,x0]*D[xib,x1] /(xi*xib)
//		double RJp		= xi[2]/xi0[2];
//		double RJd		= RJp/A;
//
//		plus_x2.set_Jacs(RJp,RJd);
//		plus_x2.set_Gs(0.,0.);
//#endif
//	}

public:

	inline bool init(const double sS, const double M){
		_init(sS,M);
		y_Limits.init(sS,M);
		return (M_Limits.contains(M));
	}

	inline bool init(const double sS, const double M, const OPS_Cuts& op_c){
		_init(sS,M);
		y_Limits.init(sS,M,op_c);
		return (M_Limits.contains(M));
	}

	inline bool set_qT_get_ok(const double qT){
//		NS_Utils::DOUT dout("Kinematics::set_qT_get_ok","qT");
		_set_qT(qT);

		return y_Limits.set_qT(qT);
	}

	inline bool set_qT_y_get_ok(const double qT, const double y){
//		NS_Utils::DOUT dout("Kinematics::set_qT_y_get_ok","qT,y");
		_set_qT(qT);
		y_Limits.update_qT_y_get_Jac(qT,y);
		return _set_y();
	}

	inline bool update_y_get_OK(const double xx[1]){
//		NS_Utils::DOUT dout("Kinematics::update_y_get_OK","xx");
		y_Limits.update_y_get_Jac(xx);
		return _set_y();
	}

	inline bool update_zzb_get_OK(const double xx[2]){
//		NS_Utils::DOUT dout("Kinematics::update_zzb_get_OK","xx");
		if(z_Limits.update_zz_get_OK(z,xx)){
			Jac_z	= z_Limits.Jac;
			return _set_z(xx);
		}else{
			cerr	<<"***************************************************************"<<endl
					<<"**** Kinematics::update_zzb_xixib_get_OK(xx)"<<endl
					<<"**** z =["<<z[0]<<","<<z[1]<<"] out of range"<<endl
					<<"**** Cuba.xx=["<<xx[0]<<","<<xx[1]<<"]"<<endl
					<<"**** xipm =["<<xi_pm[0]<<","<<xi_pm[1]<<"]"<<endl
					<<"**** y ="<<endl
					<<"***************************************************************"<<endl;
		}
		return false;
	}

	inline bool update_y_zzb_get_OK(const double yxx[3]){
		if(update_y_get_OK(yxx)) return update_zzb_get_OK(++yxx);
		else return false;
	}

	inline bool update_zzb_and_xixib_get_OK(const double xx[2]){
		if(z_Limits.update_zz_get_OK(z,xx)){
			Jac_z	= z_Limits.Jac;
			if(_set_z(xx)) return xi_Limits.update_xi_get_OK(xx,z,Jac_z);
		}else{
			cerr	<<"***************************************************************"<<endl
					<<"**** Kinematics::update_zzb_xixib_get_OK(xx)"<<endl
					<<"**** z =["<<z[0]<<","<<z[1]<<"] out of range"<<endl
					<<"**** Cuba.xx=["<<xx[0]<<","<<xx[1]<<"]"<<endl
					<<"**** xipm =["<<xi_pm[0]<<","<<xi_pm[1]<<"]"<<endl
					<<"**** y ="<<endl
					<<"***************************************************************"<<endl;
		}
		return false;
	}

	inline bool update_y_zzb_and_xixib_get_OK(const double yxx[3]){
		if(update_y_get_OK(yxx)) return update_zzb_and_xixib_get_OK(++yxx);
		else return false;
	}

	Kinematics()
	:S(),sS()
	,M_Limits(),M(),M2()
	,qT_Limits(),qT(),qT2(),mT(),mT2(),lT2(),tau()
	,y_Limits(),y(),e_pm_y()
	,Jac_y()
	,xi_pm()
	,z_Limits(),z(),Jac_z()
	,stux2(xi_pm),xi_Limits(stux2){

	}
};


}  // namespace NS_Kinematics
}  // namespace CuTe

#endif

