#ifndef RES_IQI_H
#define RES_IQI_H

#include "Ibar.h"
#include "charges.h"


namespace CuTe {

namespace NS_Resumed {

using NS_Ibar::Ibar_Parameter;
using NS_Ibar::Ibar_G_Parameter;
using NS_Ibar::Ibar_Q_Parameter;
using NS_Ibar::VectorbarI;
using NS_Ibar::VectorbarI_H;
using NS_Ibar::VectorbarI_DY;

//using NS_Polynom::Continious_Order_Reduction;

using namespace NS_enums::NS_PROD;
using namespace NS_enums::NS_Partons;

using NS_CHARGES::Q_Matrix;
using NS_CHARGES::CKM_MATRIX;

//using NS_CS_Params::CS_params;

using NS_Kinematics::Kinematics;
using NS_Polynom::Pol;

using std::cerr;
//using std::complex;
using std::endl;
using std::string;
//using std::stringstream;
using std::vector;




class IQI: public Pol< Pol<double> >{
protected:
	PROD prod;
	int ord_a_or_e;
	bool improved;

	const double* as;
	const int* nf;

	Q_Matrix _Q;

	vector<VectorbarI_DY>	_IV;
	vector<VectorbarI_H>	_IS;
	vector<VectorbarI*>		_I;

	VectorbarI::const_iterator	i0_q;
	VectorbarI::const_iterator	i0bq;
//	VectorbarI::const_iterator	i1_nf;
//	VectorbarI::const_iterator	i1bnf;
	VectorbarI::const_iterator	i1_g;
	VectorbarI::const_iterator	i1_p_;
	VectorbarI::const_iterator	i1_pb;
	Vector<N_PARTONS,double>::const_iterator iQbqp_;
	Vector<N_PARTONS,double>::const_iterator iQ_qpb;

	Pol< Pol<double> > tmp_qQpb;
	Pol< Pol<double> > tmpbqQp_;

	inline void _calc_prod(){//const Continious_Order_Reduction *reduction=NULL){
//		NS_Utils::DOUT dout("IQI::_calc_prod");
		order(0);
		_P[0].order(0);
		_P[0][0]=0.;
		if( (prod==PROD_Higgs)||(prod==PROD_H_RS) ){
//			DOUT dout("IQI::_calc_prod");
//			dout()	<<"xi=["<<xi[0]<<","<<xi[1]<<"]"	<<"\ta="<<*a	<<endl;
//			dout()	<<"I[0][0]="<<(*(_I[0]))[0]	<<endl;
//			dout()	<<"I[0][1]="<<(*(_I[0]))[1]	<<endl;
//			dout()	<<endl;
//			dout()	<<"I[1][0]="<<(*(_I[1]))[0]	<<endl;
//			dout()	<<"I[1][1]="<<(*(_I[1]))[1]	<<endl;

			set_equalt_to((*_I[0])[0].mul_by_Pol((*_I[1])[0],ord_a_or_e),ord_a_or_e);
			add_this_Pol((*_I[0])[1].mul_by_Pol((*_I[1])[1],ord_a_or_e),ord_a_or_e);

		}else{

//			NS_Utils::DOUT dout("IQI::_calc_prod","prod_V");
//			NS_Utils::Timer timer;
//
//			_Q.to_stream(cout,3,dout.get_ntab());
//
//			Pol<Pol<double> > Erg;
//			const int  Dnf(N_FMAX+(*nf));
//			const int Dbnf(N_FMAX-(*nf));
//
//
//			i0_q	= _I[0]->begin()+Dnf;
//			i0bq	= _I[0]->begin()+Dbnf;
//			VectorbarI::const_iterator	i1_nf;
//			VectorbarI::const_iterator	i1bnf;
//			i1_nf	= _I[1]->begin()+Dnf;
//			i1bnf	= _I[1]->begin()+Dbnf;
//
//			timer.start();
//			for(int q(*nf); q>0; --q){
//				iQ_qpb	= _Q[N_FMAX+q].begin()+Dbnf;
//				iQbqp_	= _Q[N_FMAX-q].begin()+Dnf;
//				i1_p_	= i1_nf;
//				i1_pb	= i1bnf;
//				for(int p(Dbnf); p<N_FMAX; ++p){
//					if((*iQ_qpb)!=0.){
//						Erg.add_this_Pol(((*i0_q).mul_by_Pol(*i1_pb,ord_a_or_e)).mul_by_scalar(*iQ_qpb),ord_a_or_e);
//					}
//					if((*iQbqp_)!=0.){
//						Erg.add_this_Pol(((*i0bq).mul_by_Pol(*i1_p_,ord_a_or_e)).mul_by_scalar(*iQbqp_),ord_a_or_e);
//					}
//					++iQ_qpb;
//					--iQbqp_;
//					++i1_pb;
//					--i1_p_;
//				}
//				++i0bq;
//				--i0_q;
//			}
//			timer.stop();
//			dout() << "Erg("<<timer<<"):"<<endl<<Erg<<endl;

			tmp_qQpb.order(0);	tmp_qQpb[0].order(0);	tmp_qQpb[0][0]=0.;
			tmpbqQp_.order(0);	tmpbqQp_[0].order(0);	tmpbqQp_[0][0]=0.;

			const Parton NF(*nf);

			i0_q=i0bq	= &((*(_I[0]))(Parton_g));//_I[0]->begin()+Parton_g.i;
			i1_g		= &((*(_I[1]))(Parton_g));//_I[1]->begin()+Parton_g.i;

			Vector<N_FMAX+1,bool>::const_iterator is_active_flv(&(_Q.is_active_flv(Parton_g)));

//			timer.start();
			for(Parton q(1); q<=NF; ++q){
				if(*(++is_active_flv)){

					iQbqp_	= &(_Q(-q,Parton_g));
					iQ_qpb	= &(_Q(+q,Parton_g));
					i1_p_	= i1_pb	= i1_g;
					tmpbqQp_.mul_this_by_scalar(0.);
					tmp_qQpb.mul_this_by_scalar(0.);

					for(Parton p(1); p<=NF; ++p){
						tmpbqQp_.add_to_this_x_times_P(*(++iQbqp_),*(++i1_p_),ord_a_or_e);
						tmp_qQpb.add_to_this_x_times_P(*(--iQ_qpb),*(--i1_pb),ord_a_or_e);
					}

					tmp_qQpb.mul_this_by_Pol((*(++i0_q)),ord_a_or_e);
					tmpbqQp_.mul_this_by_Pol((*(--i0bq)),ord_a_or_e);

					add_this_Pol(tmp_qQpb,ord_a_or_e);
					add_this_Pol(tmpbqQp_,ord_a_or_e);
				}else{
					++i0_q;
					--i0bq;
				}
			}
//			timer.stop();
//			dout() << "Erg("<<timer<<"):"<<endl<<*this<<endl;
		}
#ifdef ONLY_MIXED
		_P[0][0]=0.;
#endif
		set_of(*as);

//		cout << "IQI::_calc_prod:"<<endl<<Erg	<< endl;

//		dout()	<<"prod="<<endl;
//		dout()	<<*this<<endl;

//		if(reduction!=NULL) reduction->reduce_this_Pol_a_l(*this);

		if(improved){
//			dout()	<<"before imp:"<<*this<<endl;
			improve_Pol_a_l(*this,ord_a_or_e);
//			dout()	<<"prod_improved="<<endl;
		}

	}

	inline void _set_I(PROD prod){
		switch (prod) {
		case PROD_Higgs:
		case PROD_H_RS:
			for(int i=0; i<2; ++i){
				_I[i] = &(_IS[i]);
			}
			break;
		default:
			for(int i=0; i<2; ++i){
				_I[i] = &(_IV[i]);
			}
			break;
		}
	}

public:

	inline void init(
					PROD prod, int ord_a_or_e, bool improved
					,const vector<NS_LHAFUNC::PDF> &pdfs
					,const double *mu,const double *as, const int *nf
					,const CKM_MATRIX &ckm, double Theta_W, const Vector<N_FMAX+1,bool>& active_flavour
					){
//		DOUT dout("IQI::init","p");
//		dout()	<<"ord="<<ord_a_or_e	<<"\timp="<<improved	<<endl;

		this->prod			= prod;
		this->ord_a_or_e	= ord_a_or_e;
		this->improved		= improved;

		this->as			= as;
		this->nf			= nf;

		_Q 					= Q_Matrix(prod,ckm,Theta_W,active_flavour);


		_set_I(prod);

		for(int i=0;i<2;++i){
			_I[i]->init(pdfs[i],mu,nf,&(_Q.is_active_flv(Parton_g)));
//			_IV[i].init(pdfs[i],mu,nf);
//			_IS[i].init(pdfs[i],mu,nf);
		}

	}

//	template< RES res >
//	inline void init(const CS_params<res>* p){
//		init(p->prod,p->order,p->improved,p->pdfs,&(p->mu),&(p->a),&(p->nf),p->ckm,p->Theta_W);
//	}


	inline void set_y(const Ibar_Parameter_Set &IPS){
//		DOUT dout("IQI::set_y");

//		cout<<IPS[0]->to_String(dout.get_ntab());
//		cout<<IPS[1]->to_String(dout.get_ntab());


//		dout()	<<"y="<<p->y	<<endl;
		_I[0]->set_xi(IPS[0]);
		_I[1]->set_xi(IPS[1]);
	}

	inline IQI()
	:Pol< Pol<double> >(5,Pol<double>(5,0.))
	,prod(),ord_a_or_e(),improved()
	,as(NULL),nf(NULL)
	,_Q()
	,_IV(2,VectorbarI_DY())
	,_IS(2,VectorbarI_H())
	,_I(2,static_cast<VectorbarI*>(NULL))
	,i0_q(),i0bq()
	,i1_g(),i1_p_(),i1_pb()
	,iQ_qpb(),iQbqp_()
	,tmp_qQpb(5,Pol<double>(5,0)),tmpbqQp_(5,Pol<double>(5,0)){
	}

	inline IQI(const IQI &iqi)
	:Pol< Pol<double> >(5,Pol<double>(5,0.))
	,prod(iqi.prod),ord_a_or_e(iqi.ord_a_or_e),improved(iqi.improved)
	,as(iqi.as),nf(iqi.nf)
	,_Q(iqi._Q)
	,_IV(iqi._IV)
	,_IS(iqi._IS)
	,_I(2,static_cast<VectorbarI*>(NULL))
	,i0_q(),i0bq()
	,i1_g(),i1_p_(),i1_pb()
	,iQ_qpb(),iQbqp_()
	,tmp_qQpb(5,Pol<double>(5,0)),tmpbqQp_(5,Pol<double>(5,0)){
//		DOUT	dout("IQI","iqi");

		set_equalt_to(iqi);
		if((iqi._I[0]!=NULL)&&(iqi._I[1]!=NULL))	_set_I(prod);
	}

	inline IQI& operator=(const IQI &iqi){
//		DOUT	dout("IQI::operator=","iqi");
		set_equalt_to(iqi);

		prod		= (iqi.prod);
		ord_a_or_e	= (iqi.ord_a_or_e);
		improved	= (iqi.improved);
		as			= (iqi.as);
		nf			= (iqi.nf);
		_Q			= (iqi._Q);

		_IV			= (iqi._IV);
		_IS			= (iqi._IS);

		if((iqi._I[0]!=NULL)&&(iqi._I[1]!=NULL)){
			_set_I(prod);
		}else{
			_I.assign(2,static_cast<VectorbarI*>(NULL));
		}

		return *this;

	}

	inline Pol< Pol<double> >& update_zz(const Ibar_Parameter_Set &IPS){//, const Continious_Order_Reduction *reduction=NULL){
//		NS_Utils::DOUT dout("IQI::update_zz","IPS");
//		dout()<<"zz=["<<IPS[0]->z<<","<<IPS[1]->z<<"]"<<endl;
//		cout<<IPS[0]->to_String(dout.get_ntab());
//		cout<<IPS[1]->to_String(dout.get_ntab());


		_I[0]->update_z(IPS[0]);
		_I[1]->update_z(IPS[1]);
		_calc_prod();//reduction);

//		properties(cout,dout.get_ntab());

//		dout()	<<"this:"<<endl;
//		dout()	<<*this<<endl;

		return *this;
//		cout << "iqi[0] = " << _P[0][0] << endl;
	}


	inline ~IQI(){
	}

	inline void print_pdf(const string s="")const{
		_I[0]->print_pdf(s+"0");
		_I[1]->print_pdf(s+"1");
	}

	inline const string TDPDF_to_String(int ntabs=0)const{
		std::stringstream ss;
		for(int i=0; i<ntabs; ++i) ss<<"\t";
		std::string tab(ss.str());
		ss.str(string());

		ss	<<tab<<"_I[0]:"<<endl;
		ss	<< _I[0]->to_String(ntabs+1);
		ss	<<tab<<"_I[1]:"<<endl;
		ss	<< _I[1]->to_String(ntabs+1);

		return ss.str();
	}

	inline std::ostream& properties(std::ostream &os, const int ntab=0)const{
		std::string tab;
		for(int i=0; i<ntab; ++i) tab += "\t";
		os	<<tab<<"IQI:"<<endl;
		os	<<tab;
		os	<<"\t"<<"iqi = "<<*this;
		os	<<endl;
		os	<<tab;
		os	<<"\t"<<"as = "<<*as;
		os	<<"\t"<<"nf = "<<*nf;
		os	<<endl;
		os	<<_I[0]->to_String(ntab+1);
		os	<<_I[1]->to_String(ntab+1);
		return os;
	}

	inline void change_PDF(const vector<NS_LHAFUNC::PDF> &pdfs){
//		const double* as;
//		const int* nf;
		(_I[0])->change_PDF(pdfs[0]);
		(_I[1])->change_PDF(pdfs[1]);

	}

};

}  // namespace NS_IQI

}  // namespace CuTe
#endif
