#ifndef ENUMS_H
#define ENUMS_H

//#include "op_exceptions.h"
#include <iostream>
#include <sstream>
#include <cstdlib>

#include "op_exceptions.h"

//namespace NS_OPTIONS {
//	class bad_in_exception;
//}  // namespace NS_OPTIONS

namespace CuTe {
namespace NS_enums {

namespace NS_COL {
	enum COL {COL_PP, COL_PbarP, COL_PbarPbar, COL_WRONG};
	std::istream& operator>>(std::istream& is, COL& col );
	std::ostream& operator<<(std::ostream& os, const COL col);
}  // namespace NS_COL

namespace NS_PROD {
	enum PROD {PROD_DY, PROD_Z, PROD_W, PROD_Higgs, PROD_WRONG_STATEMENT, PROD_H_RS};
	std::istream& operator>>(std::istream& is, PROD& prod);
	std::ostream& operator<<(std::ostream& os, const PROD prod);
}  // namespace NS_PROD

namespace NS_RES {
	enum RES {RES_LO, RES_LL, RES_LLO, RES_MATCHED, RES_MATCHING_CORR,  RES_RES_CORR, RES_WRONG_STATEMENT};
	std::istream& operator>>(std::istream& is, RES& res);
	std::ostream& operator<<(std::ostream& os, const RES res);

	const std::string long_str(const RES res);
}  // namespace NS_RES

namespace NS_NP {
	enum CUTOFF {CUTOFF_NO, CUTOFF_GAUSS, CUTOFF_DIPOL, CUTOFF_ENHANCED, CUTOFF_HARD, CUTOFF_WRONG, CUTOFF_GAUSS_HALF, CUTOFF_DIPOL_HALF, CUTOFF_ENHANCED_HALF};
	std::ostream& operator<<(std::ostream& os, const CUTOFF cutoff);
	std::istream& operator>>(std::istream& is, CUTOFF& cutoff);
}  // namespace NS_NP

namespace NS_MS {
	enum MS{ MS_NAIVE, MS_VAR_QT, MS_VAR_MU, MS_WRONG, MS_VAR_MU_PI2 , MS_VAR_QT_PI2, MS_CONST_MU, MS_CONST_QT, MS_CONST_MU_PI2, MS_CONST_QT_PI2};
	std::istream& operator>>(std::istream& is, MS& ms );
	std::ostream& operator<<(std::ostream& os, const MS ms);
}  // namespace NS_MS

namespace NS_CUBA {
	enum CUBA_R{ CUBA_R_VEGAS, CUBA_R_SUAVE, CUBA_R_CUHRE, CUBA_R_DIVONNE, CUBA_R_WRONG};
	std::istream& operator>>(std::istream& is, CUBA_R& cr);
	std::ostream& operator<<(std::ostream& os, const CUBA_R cr);
}  // namespace NS_CUBA

namespace NS_PC {
	enum POWER_COUNTING{ PC_NAIVE, PC_STD, PC_IMP, PC_WRONG, PC_NO_RES};
	std::istream& operator>>(std::istream& is, POWER_COUNTING& pc);
	std::ostream& operator<<(std::ostream& os, const POWER_COUNTING pc);
}  // namespace NS_PC

namespace NS_RESULTS {
	enum E_RESULTS { ER_qT	,ER_mu, ER_y
					,ER_erg_result
					,ER_erg_RES, ER_erg_FO, ER_erg_SQT, ER_erg_MC, ER_erg_RC
					,ER_erg_Delta	,ER_erg_mu_P	,ER_erg_mu_M	,ER_erg_PDF_Delta	,ER_erg_PDF_DeltaP	,ER_erg_PDF_DeltaM	,ER_erg_PDF_Scale
					,ER_erg_exp
					,ER_erg_DCP	,ER_erg_DCM
	//				,ER_LL	,ER_LL_Delta	,ER_LL_mu_P		,ER_LL_mu_M		,ER_LL_PDF_Delta	,ER_LL_PDF_DeltaP	,ER_LL_PDF_DeltaM
	//				,ER_LLO	,ER_LLO_Delta	,ER_LLO_mu_P	,ER_LLO_mu_M	,ER_LLO_PDF_Delta	,ER_LLO_PDF_DeltaP	,ER_LLO_PDF_DeltaM
	//				,ER_LO	,ER_LO_Delta	,ER_LO_mu_P		,ER_LO_mu_M		,ER_LO_PDF_Delta	,ER_LO_PDF_DeltaP	,ER_LO_PDF_DeltaM
					,ER_Last
	};
	std::istream& operator>>(std::istream& is, E_RESULTS& R);
	std::ostream& operator<<(std::ostream& os, const E_RESULTS R);

	const std::string long_str(const E_RESULTS R);
}  // namespace NS_RESULTS

////enum LHA_ERROR_TYPE {LHA_ERR_replicas, LHA_ERR_symmhessian, LHA_ERR_hessian, LHA_ERR_none, LHA_ERR_UNKNOWN, LHA_ERR_custom, LHA_ERR_wrong};
//std::ostream& operator<<(std::ostream& os, const LHA_ERROR_TYPE et);
//std::istream& operator>>(std::istream& is, LHA_ERROR_TYPE& et);

namespace NS_BFUNCS {
	enum ENUM_B_FUNCS {E_BFUNC_Bbar,E_BFUNC_B,E_BFUNC_FB/*,E_BFUNC_BbarTilde,E_BFUNC_BTilde,E_BFUNC_FBTilde*/,E_BFUNC_WRONG};
	std::istream& operator>>(std::istream& is, ENUM_B_FUNCS& B);
	std::ostream& operator<<(std::ostream& os, const ENUM_B_FUNCS B);
}	// namespace NS_BFUNCS

namespace NS_MU_OPS {
	enum ENUM_MU_CONST_OPTION { ENUM_MU_M,  ENUM_MU_QT, ENUM_MU_MU_STAR, ENUM_MU_WRONG, ENUM_MU_QSV, ENUM_MU_QSS, ENUM_MU_LP0, ENUM_MU_B0};
	std::istream& operator>>(std::istream& is, ENUM_MU_CONST_OPTION& mu );
	std::ostream& operator<<(std::ostream& os, const ENUM_MU_CONST_OPTION mu);
}  // namespace NS_MU_OPS

namespace NS_TD_PARTON {
	enum ENUM_TDPDF_Parton {e_B_t_bar, e_B_b_bar, e_B_c_bar, e_B_s_bar, e_B_u_bar, e_B_d_bar, e_B_G/*sqrt(G1^2+G2^2)*/, e_B_d, e_B_u, e_B_s, e_B_c, e_B_b, e_B_t, e_B_G1, e_B_G2,ENUM_TDPDF_Parton_WRONG};
	std::istream& operator>>(std::istream& is, ENUM_TDPDF_Parton& e_B );
	std::ostream& operator<<(std::ostream& os, const ENUM_TDPDF_Parton e_B);
}  // namespace NS_TD_PARTON


//namespace NS_Stepfunction {
//	enum ENUM_Stepfunction_Type {SFT_ETA,SFT_No,SFT_WRONG,SFT_Erf,SFT_Logistic,SFT_Gompertz};
//	std::istream& operator>>(std::istream& is, ENUM_Stepfunction_Type& type );
//	std::ostream& operator<<(std::ostream& os, const ENUM_Stepfunction_Type type);
//}	// namespace NS_Stepfunction


namespace NS_Transition_Function {
	enum ENUM_Transition_Function_Type {TFT_NO,TFT_LOG,TFT_ERF,TFT_GPZ,TFT_MGPZ,TFT_WRONG,TFT_LAST};
	std::istream& operator>>(std::istream& is, ENUM_Transition_Function_Type& type );
	std::ostream& operator<<(std::ostream& os, const ENUM_Transition_Function_Type type);


	enum ENUM_Transition_Function_Arg {TFA_ETA,TFA_LAMBDA,TFA_LAMBDA2,TFA_WRONG,TFA_LAST};
	std::istream& operator>>(std::istream& is, ENUM_Transition_Function_Arg& arg);
	std::ostream& operator<<(std::ostream& os, const ENUM_Transition_Function_Arg arg);
}	// namespace NS_Transition_Function


namespace NS_Partons {

static const int N_PARTONS(13);
static const int N_FMAX(6);

class Parton {
public:
	int i;

	inline Parton():i(N_FMAX){}
	inline explicit Parton(const int _lha_):i(_lha_+N_FMAX){}

	inline Parton& init_by_lha(int lha){
		i	= lha + N_FMAX;
		return *this;
	}

	inline Parton& init_by_index(int i){
		this->i	= i;
		return *this;
	}

	inline const Parton bar()const{
		return Parton(-lha());
	}

	inline int lha()const{return (i-N_FMAX);}

	inline bool is_downtype()const{ return i%2; }
	inline bool is_uptype()const{ return !is_downtype(); }

	inline Parton& operator++(){
		//		++_lha;
		++i;
		return *this;
	}

	inline Parton& operator--(){
		//		--_lha,
		--i;
		return *this;
	}

	inline const Parton operator++(int){
		Parton tmp(lha());
		++(*this);
		return tmp;
	}

	inline const Parton operator--(int){
		Parton tmp(lha());
		--(*this);
		return tmp;
	}

	inline const Parton& operator+()const{
		return *this;
	}

	inline const Parton operator-()const{
		return Parton(-lha());
	}

	inline bool operator<(const Parton& q)const{
		return i<q.i;
	}

	inline bool operator<=(const Parton& q)const{
		return i<=q.i;
	}

	inline bool operator>(const Parton& q)const{
		return i>q.i;
	}

	inline bool operator>=(const Parton& q)const{
		return i>=q.i;
	}

	inline bool operator==(const Parton& q)const{
		return i==q.i;
	}

	inline bool operator!=(const Parton& q)const{
		return i!=q.i;
	}

	inline int flv()const{
		return abs(lha());
	}

	inline double sgn()const{
		const int tmp(lha());
		if(tmp>0) return +1.;
		if(tmp<0) return -1.;
		return 0.;
	}
};

static const Parton Parton_tbar(-6);
static const Parton Parton_bbar(-5);
static const Parton Parton_cbar(-4);
static const Parton Parton_sbar(-3);
static const Parton Parton_ubar(-2);
static const Parton Parton_dbar(-1);
static const Parton Parton_g( 0);
static const Parton Parton_d( 1);
static const Parton Parton_u( 2);
static const Parton Parton_s( 3);
static const Parton Parton_c( 4);
static const Parton Parton_b( 5);
static const Parton Parton_t( 6);

std::ostream& operator<<(std::ostream& os, const Parton& q);


}  // namespace NS_Partons


template< typename T >
std::string enum_list(){
	static const int NMAX=20;
	std::stringstream ss;
	std::stringstream tmp;
	T t;
	ss << "[";

	for(int i(0); i<NMAX; ++i){
		t = static_cast<T>(i);
		try {
			tmp << t;
			tmp >> t;
			tmp.clear();
		} catch(const NS_OPTIONS::bad_in_exception& e) {
			break;
		}
		if(i!=0) ss << ", ";
		ss << t;
	}
	ss << "]";
	return ss.str();
}


}  // namespace NS_enums



}  // namespace CuTe

#endif
